<?php

class MongoEntityRestWSFormatJSON extends RestWSFormatJSON {

  protected function getResourceReferenceValue($type, array $reference) {

    // Is this a new embedded entity? Let's find out
    if ($type != 'entity') {

      $entity_types = explode(':', $type);
      $embedded_entity_type = array_pop($entity_types);

      if ($controller = _mongo_entity_get_embedded_entity_controller($embedded_entity_type)) {

        // Get the property values for any fields in this reference
        $property_info = entity_get_all_property_info($embedded_entity_type);
        $this->getPropertyValues($reference, $property_info);

        // Create a new entity from this wrapper
        $wrapper = entity_property_values_create_entity($embedded_entity_type, $reference);
        return $wrapper->value();

      }

    }

    return parent::getResourceReferenceValue($type, $reference);

  }

  public function getData($wrapper) {

    // Convert MongoEntity objects to property references
    $data = parent::getData($wrapper);
    foreach ($data as $name => $property) {
      if ($property instanceof MongoEntity) {
        $property_wrapper = entity_metadata_wrapper($property->entityType(), $property);
        $data[$name] = $this->getData($property_wrapper);
      }
    }
    return $data;

  }

}

